Raphael 10, 10, 1000, 400, ->
  r = this

  r.rect(0, 0, 1000, 400, 10).attr
    stroke: "none"
    fill: "0-#9bb7cb-#adc8da"

  over = ->
    $('#name').text worldmap.names[this.code]
    @c = this.c || this.attr("fill")
    @stop().animate(fill: "#bacabd", 500)

  out = ->
    @stop().animate(fill: this.c, 500)

  start = ->
    node = $(this.node)
    node.attr('code')
    parent = node.parent()
    parent.append node
    @ox = @attr("cx")
    @oy = @attr("cy")
    @animate
      fill: "black"
      r: 70
    , 500, ">"

  move = (dx, dy) ->
    trans_x = dx-this.ox
    trans_y = dy-this.oy
    this.translate trans_x, trans_y
    this.ox = dx
    this.oy = dy

  end = ->
    @animate
      fill: "white"
      r: 70
    , 500, ">"

  r.setStart()
  hue = Math.random()
  for country of worldmap.shapes
    # var c = Raphael.hsb(Math.random(), .5, .75);
    # var c = Raphael.hsb(.11, .5, Math.random() * .25 - .25 + .75);
    node = r.path(worldmap.shapes[country]).attr
      stroke: "#ccc6ae"
      fill: "#f0efeb"
      "stroke-opacity": 0.25
    node.code = country

  world = r.setFinish()
  world.drag move, start, end
  world.hover over, out

  # world.animate({fill: "#666", stroke: "#666"}, 2000);
  world.getXY = (lat, lon) ->
    cx: lon * 2.6938 + 465.4
    cy: lat * -2.6938 + 227.066

  world.getLatLon = (x, y) ->
    lat: (y - 227.066) / -2.6938
    lon: (x - 465.4) / 2.6938

  latlonrg = /(\d+(?:\.\d+)?)[\xb0\s]?\s*(?:(\d+(?:\.\d+)?)['\u2019\u2032\s])?\s*(?:(\d+(?:\.\d+)?)["\u201d\u2033\s])?\s*([SNEW])?/i
  world.parseLatLon = (latlon) ->
    m = String(latlon).split(latlonrg)
    lat = m and +m[1] + (m[2] or 0) / 60 + (m[3] or 0) / 3600
    lat = -lat  if m[4].toUpperCase() is "S"
    lon = m and +m[6] + (m[7] or 0) / 60 + (m[8] or 0) / 3600
    lon = -lon  if m[9].toUpperCase() is "W"
    @getXY lat, lon

  try
    navigator.geolocation and navigator.geolocation.getCurrentPosition((pos) ->
      r.circle().attr(
        fill: "none"
        stroke: "#f00"
        r: 5
      ).attr world.getXY(pos.coords.latitude, pos.coords.longitude)
    )

  frm = document.getElementById("latlon-form")
  dot = r.circle().attr(
    fill: "r#FE7727:50-#F57124:100"
    stroke: "#fff"
    "stroke-width": 2
    r: 0
  )
